Description

When Clicking the link to start a Server that runs on openstack we get an Error that the policy does not allow this action.

The Reason lies in
https://github.com/theforeman/foreman/blob/develop/app/models/concerns/fog_extensions/openstack/server.rb#L16. If the VM is in
mode "SHUTOFF" it can not be started with resume_server but must be called with start_server.

| suspect that five years ago when this code was written (https:/projects.theforeman.org/issues/2891). Openstack did not support the
SHUTOFF state.

| suggest adding an if option for that state (
https://github.com/cbergmann/foreman/commit/1e786556deala7e6127fd72e529fa374b62b606e€).

The second question is how to implement the stop function. Currently it is implementend with "suspend_server" but | suggest
changing this to stop_server.

In the Openstack enviroment we use (Open Telekom Cloud) the suspend Function is not allowed. VMs are only allowed to be started
and stopped.

The problem is that this change would change the behavior for existing installations. VMs that where suspended before would then
be stopped. That might irritate users.

What is your opinion on this?

Kind regards
Clemens

Associated revisions

Revision 39a7d53a - 09/21/2018 12:03 PM - Clemens Bergmann
Fixes #24965 - can't start Openstack Servers

Instead of suspending servers in openstack they should be stopped.

Revision 273d73be - 09/21/2018 12:19 PM - Stephen Benjamin

refs #24965 - add mising 'end' in openstack fog extensions

History

#1 - 09/18/2018 01:56 PM - Clemens Bergmann

- Description updated

#2 - 09/18/2018 01:59 PM - Clemens Bergmann

- Assignee set to Daniel Lobato Garcia

| suggest Daniel looks at this because he implemented the functions in the first place.

Thanks again.
Clemens
https://github.com/theforeman/foreman/blob/develop/app/models/concerns/fog_extensions/openstack/server.rb#L16
https://projects.theforeman.org/issues/2891
https://github.com/cbergmann/foreman/commit/1e786556dea1a7e6127fd72e529fa374b62b606e

#3 - 09/18/2018 06:32 PM - Marek Hulan

- Assignee deleted (Daniel Lobato Garcia)

Sorry, it's not how it works :-) Daniel might be busy with other tasks atm. Would you be interesting on working on the patch? We coukd try to help at
our dev irc channel.

#4 - 09/18/2018 09:18 PM - Clemens Bergmann
Hi,
thanks for the reply.

Sorry for the assignment. | just wanted to notify Daniel because | thought he surely had a good reasons to use suspend and tried to ask him about
these.

My suggested patch is in the commit found here: https://github.com/cbergmann/foreman/commit/1e786556deala7e6127fd72e529fa374b62b606e
Do you think this might be a valid change or would the implied change in behavior negatively affect user expectations?

#5 - 09/19/2018 10:38 AM - Marek Hulan

- Category set to Compute resources - OpenStack

I'm not openstack domain expert but the patch looks reasonable to me. Would you mind opening a PR with this patch? Hopefully someone with more
knowledge would review and test. If you're not sure about the process, please see https://theforeman.org/contribute.html#SubmitPatches

#6 - 09/21/2018 11:16 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/6085 added

#7 - 09/21/2018 12:04 PM - Lukas Zapletal
- Fixed in Releases 1.20.0 added

#8 - 09/21/2018 12:13 PM - The Foreman Bot
- Assignee set to Stephen Benjamin

- Pull request https://github.com/theforeman/foreman/pull/6086 added

#9 - 09/21/2018 01:01 PM - Anonymous
- Status changed from Ready For Testing to Closed

Applied in changeset 39a7d53a0123e72d47b70d1239f012ed325cc06d.
